## strigi 0.7.8

=== CMakeLists.txt ===
project (strigi)

# This is the aggregate build file. It serves only to call the build in the
# subdirectories. Each of the projects in the subdirectories is buildable
# separately.

cmake_minimum_required(VERSION 2.6)
# for testing to work in cmake, this command must be called in the root src dir
enable_testing()

option(STRIGI_SYNC_SUBMODULES "Try to update the Strigi submodules automatically. Note that the update may fail if you have pending changes in one of the submodules." FALSE)

if(STRIGI_SYNC_SUBMODULES)
  if (NOT GIT_EXECUTABLE)
  # Make it possible to override GIT_EXECUTABLE
    find_program(GIT_EXECUTABLE NAMES git)
  endif()
  if(NOT GIT_EXECUTABLE)
    message(FATAL_ERROR "Could not find git. Aborting.")
  endif()
endif()

macro(check_subdir _subDirectory)
  message(STATUS "Checking: ${strigi_SOURCE_DIR}/${_subDirectory}/CMakeLists.txt")
  if(NOT EXISTS "${strigi_SOURCE_DIR}/${_subDirectory}/CMakeLists.txt")
    message(STATUS "No CMakeLists.txt found in ${_subDirectory}")
    if(STRIGI_SYNC_SUBMODULES)
      message(STATUS "Trying to download the ${_subDirectory} submodule")
      execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init -- ${_subDirectory}
                      WORKING_DIRECTORY ${strigi_SOURCE_DIR})
    else()
      set(showError 1)
    endif()
  else()
    if(STRIGI_SYNC_SUBMODULES)
      message(STATUS "Trying to update the ${_subDirectory} submodule")
      execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --rebase -- ${_subDirectory}
                      WORKING_DIRECTORY ${strigi_SOURCE_DIR})
    endif()
  endif()
endmacro()

check_subdir(libstreams)
check_subdir(libstreamanalyzer)
check_subdir(strigiutils)
check_subdir(strigidaemon)
check_subdir(strigiclient)

if(MSVC)
  add_definitions(-wd4251)
  add_definitions(-wd4355)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
  add_definitions(-D_USE_MATH_DEFINES)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Zc:wchar_t-")
endif(MSVC)

if(showError)
  message(FATAL_ERROR "No CMakeLists.txt was found in one of your sources subdirectory\n"
                      "Make sure you downloaded the sub-modules files using:\n"
                      "  git submodule update --init"
         )
else()
  add_subdirectory(libstreams) # Must be first
  add_subdirectory(libstreamanalyzer) # Must be second
  add_subdirectory(strigiutils)
  if(NOT WIN32)
    add_subdirectory(strigidaemon)
  endif()
  add_subdirectory(strigiclient) # Must be AFTER strigidaemon
endif()

=== libstreamanalyzer/CMakeLists.txt ===
project (libstreamanalyzer)

##### cmake settings #####

cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)

cmake_policy(VERSION 2.6.0)
if(POLICY CMP0017)
  cmake_policy(SET CMP0017 NEW)
endif()

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(MacroCheckGccVisibility)
include(MacroFindOptionalDep)
enable_testing()

# Used to report found packages
include(FeatureSummary)

# Used to create config files
include(CMakePackageConfigHelpers)

# Used to set some generic paths
include(GNUInstallDirs)

##### global variables #####

# due to a bug in libxml2, we only get thread support if _REENTRANT is defined
add_definitions(-D_REENTRANT)

set(LIBSTREAMANALYZER_VERSION_MAJOR 0)
set(LIBSTREAMANALYZER_VERSION_MINOR 7)
set(LIBSTREAMANALYZER_VERSION_PATCH 8)
set(LIBSTREAMANALYZER_VERSION ${LIBSTREAMANALYZER_VERSION_MAJOR}.${LIBSTREAMANALYZER_VERSION_MINOR}.${LIBSTREAMANALYZER_VERSION_PATCH})
set(LIBSTREAMANALYZER_SOVERSION ${LIBSTREAMANALYZER_VERSION_MAJOR})

option(BUILD_UTILS "build luceneindexer, xmlindexer, rdfindexer, ontoprint utilities" ON)
option(BUILD_DEEPTOOLS "build deep find and deepgrep tools" ON)
option(ENABLE_XINE
       "enable Xine support. This adds support for a larger number of media formats(highly unstable)." OFF)
option(ENABLE_FFMPEG
       "enable FFMPEG support. This adds support for a larger number of media formats(testing)." ON)
option(ENABLE_EXIV2
       "enable exiv2 support. This allows you to index EXIF/IPTC metadata." ON)
set(CLUCENE_MIN_VERSION "0.9.21")
option(ENABLE_CLUCENE "enable CLucene support (recommended)" ON)
option(ENABLE_CLUCENE_NG "enable clucene-ng (version 1+) support (testing)" ON)

# (Absolute) paths definitions
set(LIB_DESTINATION     "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDE_DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(DATA_DESTINATION    "${CMAKE_INSTALL_FULL_DATAROOTDIR}")

# Set up RPATH handling, so the libs are found if they are installed to a non-standard location.
# By default cmake builds the targets with full RPATH to everything in the build directory,
# but then removes the RPATH when installing.
# These two options below make it set the RPATH of the installed targets to all
# RPATH directories outside the current CMAKE_BINARY_DIR and also the library
# install directory. Alex
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH  TRUE)
set(CMAKE_INSTALL_RPATH                ${LIB_DESTINATION} )

if(NOT WIN32 AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
  add_definitions(-fPIC)
endif()

##### environment inspection #####

# check for visibility support
macro_check_gcc_visibility(__STRIGI_HAVE_GCC_VISIBILITY)

# check for required packages
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  find_package(LibStreams REQUIRED)
else()
  set(LIBSTREAMS_INCLUDE_DIRS
    ${libstreams_SOURCE_DIR}/include
    ${libstreams_BINARY_DIR}/include
    )
  set(LIBSTREAMS_LIBRARIES streams)
endif()


find_package(Threads)
set_package_properties(Threads PROPERTIES
                       DESCRIPTION "The thread library of the system"
                       TYPE REQUIRED
                      )

if(NOT CMAKE_USE_PTHREADS_INIT AND NOT CMAKE_USE_WIN32_THREADS_INIT)
  message(FATAL_ERROR "Strigi needs either pthreads or win32 threads, none was found.")
endif()

find_package(LibXml2)
set_package_properties(LibXml2 PROPERTIES
                       URL "http://xmlsoft.org"
                       TYPE REQUIRED
                      )
find_package(Iconv)
set_package_properties(Iconv PROPERTIES
                       TYPE REQUIRED
                      )


find_optional_dep(CLucene ENABLE_CLUCENE CLucene_FOUND "CLucene backend")
find_optional_dep(CLucene1 ENABLE_CLUCENE_NG CLUCENE1_FOUND "CLucene Version 1+ backend")
find_optional_dep(Exiv2 ENABLE_EXIV2 EXIV2_FOUND "indexing of EXIF/IPTC metadata")
find_optional_dep(FFmpeg ENABLE_FFMPEG FFMPEG_FOUND "indexing FFMPEG" COMPONENTS AVCODEC AVFORMAT AVUTIL SWSCALE)
find_package(XAttr)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)


include(ConfigureChecks.cmake)

##### building and testing #####

configure_file(${libstreamanalyzer_SOURCE_DIR}/strigi_thread.h.cmake
               ${libstreamanalyzer_BINARY_DIR}/include/strigi/strigi_thread.h)

# every directory needs the headers that will be installed
include_directories(${LIBSTREAMS_INCLUDE_DIRS}
                    ${libstreamanalyzer_SOURCE_DIR}/include
                    ${libstreamanalyzer_SOURCE_DIR}/include/strigi
                    ${libstreamanalyzer_BINARY_DIR}/include
                    ${libstreamanalyzer_BINARY_DIR}/include/strigi
                    ${libstreamanalyzer_SOURCE_DIR}/lib
                    ${libstreamanalyzer_BINARY_DIR}/lib
                    ${ICONV_INCLUDE_DIR}
                    ${LIBSTREAMS_LIBRARY_DIRS}
                    ${EXIV2_INCLUDEDIR}
                    ${XINE_INCLUDE_DIR}
                    ${FFMPEG_INCLUDE_DIRS}
                    ${MAGIC_INCLUDE_DIR}
                    ${LIBXML2_INCLUDE_DIR}
)
if(XATTR_FOUND)
  include_directories(${XATTR_INCLUDE_DIR})
endif()

add_subdirectory(lib)
add_subdirectory(plugins)
#add_subdirectory(tests)

##### installing #####

# all installed files are listed here
# headers
file(GLOB STRIGI_HEADERS include/strigi/*.h)
install(FILES
        ${STRIGI_HEADERS}
        ${libstreamanalyzer_BINARY_DIR}/include/strigi/strigi_thread.h
        DESTINATION ${INCLUDE_DESTINATION}/strigi
)

configure_package_config_file(LibStreamAnalyzerConfig.cmake.in
                              ${CMAKE_CURRENT_BINARY_DIR}/LibStreamAnalyzerConfig.cmake
                              INSTALL_DESTINATION ${LIB_DESTINATION}/cmake/LibStreamAnalyzer
                              PATH_VARS INCLUDE_DESTINATION LIB_DESTINATION
)

write_basic_package_version_file(${libstreamanalyzer_BINARY_DIR}/LibStreamAnalyzerConfigVersion.cmake
                                 VERSION ${LIBSTREAMANALYZER_VERSION}
                                 COMPATIBILITY SameMajorVersion
                                )

install(FILES ${libstreamanalyzer_BINARY_DIR}/LibStreamAnalyzerConfig.cmake
              ${libstreamanalyzer_BINARY_DIR}/LibStreamAnalyzerConfigVersion.cmake
        DESTINATION ${LIB_DESTINATION}/cmake/LibStreamAnalyzer)

# ontologies
file (GLOB STRIGI_ONTOLOGIES share/strigi/fieldproperties/*.rdfs)
install(FILES ${STRIGI_ONTOLOGIES}
        DESTINATION ${DATA_DESTINATION}/strigi/fieldproperties/
)

# library
if(NOT WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lib/libstreamanalyzer.pc.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/lib/libstreamanalyzer.pc)

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib/libstreamanalyzer.pc
          DESTINATION ${LIB_DESTINATION}/pkgconfig)
endif()

=== libstreams/CMakeLists.txt ===
project (libstreams)

##### cmake settings #####
cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(MacroCheckGccVisibility)
enable_testing()

# Used to report found packages
include(FeatureSummary)

# Used to create config files
include(CMakePackageConfigHelpers)

# Used to set some generic paths
include(GNUInstallDirs)

##### global variables #####

# libstreams defines the definitions shared by the Strigi projects
set(STRIGI_VERSION_MAJOR 0 CACHE INT "Major Strigi version number" FORCE)
set(STRIGI_VERSION_MINOR 7 CACHE INT "Minor Strigi version number" FORCE)
set(STRIGI_VERSION_PATCH 8 CACHE INT "Release Strigi version number" FORCE)
set(STRIGI_VERSION_STRING "${STRIGI_VERSION_MAJOR}.${STRIGI_VERSION_MINOR}.${STRIGI_VERSION_PATCH}" CACHE STRING "Strigi version string" FORCE)
set(LIBSTREAMS_VERSION ${STRIGI_VERSION_STRING})

# (Absolute) paths definitions
set(LIB_DESTINATION     "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDE_DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}")

# Set up RPATH handling, so the libs are found if they are installed to a non-standard location.
# By default cmake builds the targets with full RPATH to everything in the build directory,
# but then removes the RPATH when installing.
# These two options below make it set the RPATH of the installed targets to all
# RPATH directories outside the current CMAKE_BINARY_DIR and also the library
# install directory. Alex
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH  TRUE)
set(CMAKE_INSTALL_RPATH ${LIB_DESTINATION})

if(NOT MSVC AND NOT MINGW AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
  add_definitions(-fPIC)
endif()

##### environment inspection #####

# check for visibility support
macro_check_gcc_visibility(__STRIGI_HAVE_GCC_VISIBILITY)

# Generate include/strigi/strigiconfig.h and lib/config.h
include(ConfigureChecks.cmake)

# check for required packages
find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES
                       DESCRIPTION "Support for gzip compressed files and data streams"
                       URL "http://www.zlib.net"
                       TYPE REQUIRED
                      )

find_package(BZip2)
set_package_properties(BZip2 PROPERTIES
                       DESCRIPTION "Support for BZip2 compressed files and data streams"
                       URL "http://www.bzip.org"
                       TYPE REQUIRED
                      )

find_package(Iconv)
set_package_properties(Iconv PROPERTIES
                       TYPE REQUIRED
                      )

find_package(Threads)
set_package_properties(Threads PROPERTIES
                       DESCRIPTION "The thread library of the system"
                       TYPE REQUIRED
                      )

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

##### building and testing #####
# every directory needs the headers that will be installed
include_directories(${libstreams_SOURCE_DIR}/include
                    ${libstreams_BINARY_DIR}/include
                    ${libstreams_SOURCE_DIR}/lib
                    ${libstreams_BINARY_DIR}/lib
                    ${ZLIB_INCLUDE_DIR}
                    ${BZIP2_INCLUDE_DIR}
                    ${ICONV_INCLUDE_DIR}
)

add_subdirectory(lib)
add_subdirectory(tests)

# Create the CMake Config files
configure_package_config_file(StrigiConfig.cmake.in
                              ${CMAKE_CURRENT_BINARY_DIR}/StrigiConfig.cmake
                              INSTALL_DESTINATION ${LIB_DESTINATION}/cmake/Strigi
                              PATH_VARS INCLUDE_DESTINATION LIB_DESTINATION
)

configure_package_config_file(LibStreamsConfig.cmake.in
                              ${CMAKE_CURRENT_BINARY_DIR}/LibStreamsConfig.cmake
                              INSTALL_DESTINATION ${LIB_DESTINATION}/cmake/LibStreams
                              PATH_VARS INCLUDE_DESTINATION LIB_DESTINATION
)

write_basic_package_version_file(${libstreams_BINARY_DIR}/StrigiConfigVersion.cmake
                                 VERSION ${STRIGI_VERSION_STRING}
                                 COMPATIBILITY SameMajorVersion
                                )

write_basic_package_version_file(${libstreams_BINARY_DIR}/LibStreamsConfigVersion.cmake
                                 VERSION ${STRIGI_VERSION_STRING}
                                 COMPATIBILITY SameMajorVersion
                                )


##### installing #####

# all installed files are listed here
# headers
file(GLOB STRIGI_HEADERS include/strigi/*.h)
install(FILES
      ${STRIGI_HEADERS}
      ${strigi_config_output}
      ${strigi_extra_config_output}
        DESTINATION ${INCLUDE_DESTINATION}/strigi
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/StrigiConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/StrigiConfigVersion.cmake
        DESTINATION ${LIB_DESTINATION}/cmake/Strigi)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibStreamsConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/LibStreamsConfigVersion.cmake
        DESTINATION ${LIB_DESTINATION}/cmake/LibStreams)

install(EXPORT StreamsExport FILE LibStreamsTargets.cmake
        DESTINATION ${LIB_DESTINATION}/cmake/LibStreams)

# library
if(NOT WIN32)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib/libstreams.pc
              DESTINATION ${LIB_DESTINATION}/pkgconfig)
endif()

=== strigiclient/CMakeLists.txt ===
project (strigiclient)

##### cmake settings #####

cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(MacroFindOptionalDep)
enable_testing()


##### global variables #####
option(ENABLE_QT4 "enable Qt4 GUI" ON)
set(QT_MIN_VERSION "4.3.0")

# definition of LIB_DESTINATION which is the path where the lib is installed
include(GNUInstallDirs)
set(LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

# Set up RPATH handling, so the libs are found if they are installed to a non-standard location.
# By default cmake builds the targets with full RPATH to everything in the build directory,
# but then removes the RPATH when installing.
# These two options below make it set the RPATH of the installed targets to all
# RPATH directories outside the current CMAKE_BINARY_DIR and also the library
# install directory. Alex
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH  TRUE)
set(CMAKE_INSTALL_RPATH                ${LIB_DESTINATION} )


##### environment inspection #####
find_optional_dep(Qt4 ENABLE_QT4 QT4_FOUND "Qt4 GUI client")
if(QT4_FOUND)
  # properly set up compile flags (QT_DEBUG/QT_NO_DEBUG, ...)
  include(${QT_USE_FILE})
endif(QT4_FOUND)

# check for required packages
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  find_package(LibStreams REQUIRED)
  find_package(LibStreamAnalyzer REQUIRED)
  if(NOT WIN32)
    find_package(LibSearchClient REQUIRED)
  endif()
else()
  set(LIBSTREAMS_INCLUDE_DIRS
    ${libstreams_SOURCE_DIR}/include
    ${libstreams_BINARY_DIR}/include
    )
  set(LIBSTREAMANALYZER_INCLUDE_DIRS
    ${libstreamanalyzer_SOURCE_DIR}/include
    ${libstreamanalyzer_BINARY_DIR}/include
    )
    if(NOT WIN32)
      set(LIBSEARCHCLIENT_INCLUDE_DIRS
        ${strigidaemon_SOURCE_DIR}/include
        ${strigidaemon_BINARY_DIR}/include
      )
    endif()
  set(LIBSTREAMS_LIBRARIES streams)
  set(LIBSTREAMANALYZER_LIBRARIES streamanalyzer)
endif()

##### building and testing #####

# every directory needs the headers that will be installed
include_directories(${LIBSTREAMS_INCLUDE_DIRS}
	${LIBSTREAMANALYZER_INCLUDE_DIRS}
	lib/searchclient/qtdbus
)

if(NOT WIN32)
  include_directories(${LIBSEARCHCLIENT_INCLUDE_DIRS}
                      lib/htmlgui
                      lib/searchclient/filterwidget
  )
endif()

link_directories(${LIBSTREAMANALYZER_LIBRARY_DIRS})

if(NOT WIN32)
  link_directories(${LIBSEARCHCLIENT_LIBRARY_DIRS})
endif()

add_subdirectory(lib)
add_subdirectory(bin)


##### installing #####

=== strigidaemon/CMakeLists.txt ===
project (strigidaemon)

##### cmake settings #####

cmake_minimum_required(VERSION 2.8.9 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(MacroFindOptionalDep)
enable_testing()

# Used to create config files
include(CMakePackageConfigHelpers)

# Set the installation paths
include(GNUInstallDirs)
set(LIB_DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDE_DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}")

##### global variables #####

# Set up RPATH handling, so the libs are found if they are installed to a non-standard location.
# By default cmake builds the targets with full RPATH to everything in the build directory,
# but then removes the RPATH when installing.
# These two options below make it set the RPATH of the installed targets to all
# RPATH directories outside the current CMAKE_BINARY_DIR and also the library
# install directory. Alex
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH  TRUE)
set(CMAKE_INSTALL_RPATH                ${LIB_DESTINATION} )

option(ENABLE_DBUS "enable dbus support in the daemon" ON)
option(ENABLE_INOTIFY "enable monitoring the filesystem with inotify" OFF)
option(ENABLE_FAM "enable monitoring the filesystem with FAM" ON)
option(ENABLE_POLLING "enable monitoring the filesystem via polling" ON)
option(ENABLE_LOG4CXX "enable use of the logging framework Log4CXX" ON)

if(CMAKE_SYSTEM MATCHES "Linux")
    set(ENABLE_INOTIFY ON)
endif(CMAKE_SYSTEM MATCHES "Linux")

if(NOT MSVC AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")
    add_definitions(-fPIC)
endif(NOT MSVC AND NOT CMAKE_SYSTEM MATCHES "SunOS-5*.")

##### environment inspection #####

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  find_package(LibStreams REQUIRED)
  find_package(LibStreamAnalyzer REQUIRED)
else()
  set(LIBSTREAMS_INCLUDE_DIRS
    ${libstreams_SOURCE_DIR}/include
    ${libstreams_BINARY_DIR}/include
    )
  set(LIBSTREAMANALYZER_INCLUDE_DIRS
    ${libstreamanalyzer_SOURCE_DIR}/include
    ${libstreamanalyzer_BINARY_DIR}/include
    )
  set(LIBSTREAMS_LIBRARIES streams)
  set(LIBSTREAMANALYZER_LIBRARIES streamanalyzer)
endif()

find_package(Threads REQUIRED)
find_package(LibXml2 REQUIRED)
find_optional_dep(DBus ENABLE_DBUS DBUS_FOUND "dbus inter-process communication")
find_optional_dep(FAM ENABLE_FAM FAM_FOUND "efficient file change monitoring system")
find_optional_dep(Log4cxx ENABLE_LOG4CXX LOG4CXX_FOUND "advanced logging")
#find_optional_dep(CLucene ENABLE_CLUCENE CLucene_FOUND "CLucene backend")
#find_optional_dep(Exiv2 ENABLE_EXIV2 EXIV2_FOUND "indexing of EXIF/IPTC metadata")
find_package(CppUnit)
include(ConfigureChecks.cmake)
set (LIBSEARCHCLIENT_VERSION ${STRIGI_VERSION_STRING})

configure_package_config_file(LibSearchClient.cmake.in
                              ${CMAKE_CURRENT_BINARY_DIR}/LibSearchClientConfig.cmake
                              INSTALL_DESTINATION ${LIB_DESTINATION}/cmake/LibSearchClient
                              PATH_VARS INCLUDE_DESTINATION LIB_DESTINATION
)



configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY )
IF (ENABLE_LOG4CXX AND LOG4CXX_FOUND)
    add_definitions(-DHAVE_LOG4CXX)
ENDIF (ENABLE_LOG4CXX AND LOG4CXX_FOUND)


##### building and testing #####

configure_file(${strigidaemon_SOURCE_DIR}/strigi_thread.h.cmake
               ${strigidaemon_BINARY_DIR}/include/strigi/strigi_thread.h)

include_directories(${LIBSTREAMS_INCLUDE_DIRS}
                    ${LIBSTREAMANALYZER_INCLUDE_DIRS}
                    ${strigidaemon_SOURCE_DIR}/include
                    ${strigidaemon_SOURCE_DIR}/bin/daemon/xsd
                    ${strigidaemon_BINARY_DIR}
                    ${strigidaemon_BINARY_DIR}/bin/daemon/dbus
                    ${DBUS_INCLUDE_DIRS}
                    ${ICONV_INCLUDE_DIR}
                    ${LIBXML2_INCLUDE_DIR}
                    bin/combinedindex
                    bin/daemon
)
if(LOG4CXX_FOUND)
	include_directories(${LOG4CXX_INCLUDE_DIR})
endif(LOG4CXX_FOUND)
link_directories(${LIBSTREAMS_LIBRARY_DIRS})
link_directories(${LIBSTREAMANALYZER_LIBRARY_DIRS})
link_directories(${DBUS_LIBRARY_DIRS})

add_subdirectory(lib)
add_subdirectory(bin)
if(CppUnit_FOUND)
    add_subdirectory(tests)
endif(CppUnit_FOUND)

##### installing #####

# all installed files are listed here
# headers
file(GLOB STRIGI_HEADERS include/strigi/*.h)
install(FILES
    ${STRIGI_HEADERS}
    DESTINATION include/strigi
)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibSearchClientConfig.cmake
        DESTINATION ${LIB_DESTINATION}/cmake/LibSearchClient)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/dummy.cpp "")
add_executable(strigidaemon dummy.cpp)
target_link_libraries(strigidaemon libstrigidaemon)
install(TARGETS strigidaemon
        RUNTIME DESTINATION bin)

=== libstreams/tests/CMakeLists.txt ===
add_subdirectory(internal)
add_subdirectory(api)

=== strigiclient/lib/CMakeLists.txt ===
if(NOT WIN32)
    add_subdirectory(htmlgui)
endif(NOT WIN32)
if(QT4_FOUND)
    add_subdirectory(searchclient)
endif(QT4_FOUND)

=== strigidaemon/bin/CMakeLists.txt ===
add_subdirectory(combinedindex)
add_subdirectory(strigicmd)
add_subdirectory(daemon)

=== strigidaemon/lib/CMakeLists.txt ===
add_library(searchclient SHARED socketclient.cpp
                                asyncsocket.cpp
                                asyncsocketclient.cpp
           )

set_target_properties(searchclient PROPERTIES
                      VERSION ${STRIGI_VERSION_STRING}
                      SOVERSION ${STRIGI_VERSION_MAJOR}
                      DEFINE_SYMBOL MAKE_SEARCHCLIENT_LIB
)

target_link_libraries(searchclient ${LIBSTREAMANALYZER_LIBRARIES})

install(TARGETS searchclient
        LIBRARY DESTINATION ${LIB_DESTINATION}
        RUNTIME DESTINATION bin
        ARCHIVE DESTINATION ${LIB_DESTINATION}
)

=== strigiutils/bin/CMakeLists.txt ===
# regex.c is no longer provided
if(HAVE_REGEX_H)
  add_subdirectory(deepfind)
endif(HAVE_REGEX_H)
if(NOT MSVC)
  add_subdirectory(xmlindexer)
endif(NOT MSVC)

=== libstreamanalyzer/lib/pdf/CMakeLists.txt ===
if (Magic_FOUND)
	add_executable(pdftest pdftest.cpp)
	target_link_libraries(pdftest STATIC streams ${MAGIC_LIBRARIES})
endif ()

add_library(pdfstream STATIC pdfparser.cpp)
target_link_libraries(pdfstream streams)

add_executable(pdf pdf.cpp pdfparser.cpp)
target_link_libraries(pdf streams)

=== libstreamanalyzer/plugins/endplugins/CMakeLists.txt ===
MACRO(ADD_STRIGIEA libname files)
  if(WIN32)
    # this is needed to have mingw, cygwin and msvc libs installed in one directory
    if(MSVC)
      set(prefix msvc_strigiea_)
    elseif(CYGWIN)  
      set(prefix cyg_strigiea_)
    elseif(MINGW)
      # mingw
      set(prefix mingw_strigiea_)
    endif()

  else()
    set(prefix strigiea_)
  endif()
  add_library(${libname} MODULE ${files})
  set_target_properties(${libname} PROPERTIES
    PREFIX ${prefix})
  target_link_libraries(${libname} streamanalyzer)
  install(TARGETS ${libname} LIBRARY DESTINATION ${LIB_DESTINATION}/strigi)
ENDMACRO(ADD_STRIGIEA)

if(EXIV2_FOUND)
  include_directories( ${EXIV2_INCLUDE_DIR} )
  ADD_STRIGIEA(jpeg jpegendanalyzer.cpp)
  target_link_libraries(jpeg ${EXIV2_LIBRARIES})
endif()

if(XINE_FOUND)
  ADD_STRIGIEA(xine xineendanalyzer.cpp)
  target_link_libraries(xine ${XINE_LIBRARY})
endif()

if(FFMPEG_FOUND)
  include_directories( ${FFMPEG_INCLUDE_DIRS} )
  add_definitions(-D__STDC_CONSTANT_MACROS)
  ADD_STRIGIEA(ffmpeg ffmpegendanalyzer.cpp)
  #set_target_properties( ffmpeg PROPERTIES COMPILE_FLAGS "${FFMPEG_DEFINITIONS}" )
  target_link_libraries(ffmpeg ${FFMPEG_LIBRARIES})
endif()

=== debian/changelog ===
strigi (0.7.8-2ubuntu1) xenial; urgency=medium

  * Merge with Debian; remaining changes:
    - debian/control:
      + Drop libavcodec-dev, libavformat-dev, libprostproc-dev and
        libswscale-dev from Build-Depends since they are in universe.
    - Add kubuntu_export-symbols.diff to fix compile on ppc64el

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Jan 2016 17:10:05 +0100

strigi (0.7.8-2) unstable; urgency=medium

  * Rename lib packages to their v5 version (gcc5 transition).

 -- Maximiliano Curia <maxy@debian.org>  Fri, 07 Aug 2015 18:33:38 +0200

strigi (0.7.8-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable (Closes: #739442)

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 16 May 2014 07:28:13 -0400

strigi (0.7.8-1.1) experimental; urgency=low

  * Non-maintainer upload.
  * Add libav10.patch and build against libav10 (Closes: #739442)

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 19 Mar 2014 01:03:17 +0000

strigi (0.7.8-1ubuntu5) wily; urgency=medium

  * No-change rebuild against libexiv2-14.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 06 Aug 2015 08:04:54 +0200

strigi (0.7.8-1ubuntu4) wily; urgency=medium

  * No-change rebuild for liblucene-core1v5 name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 04 Aug 2015 15:39:37 +0200

strigi (0.7.8-1ubuntu3) wily; urgency=medium

  * Renamed libraries for gcc5 transition (Closes: #791356)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 30 Jul 2015 13:30:35 +0200

strigi (0.7.8-1ubuntu2build1) utopic; urgency=medium

  * No change rebuild against new libexiv2-13

 -- Robert Ancell <robert.ancell@canonical.com>  Fri, 04 Jul 2014 15:05:03 +1200

strigi (0.7.8-1ubuntu2) trusty; urgency=medium

  * Add kubuntu_export-symbols.diff to fix compile on ppc64el

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 05 Mar 2014 12:53:33 +0000

strigi (0.7.8-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable. (LP: #1281340) Remaining changes:
    - debian/control:
      + Drop libavcodec-dev, libavformat-dev, libprostproc-dev and
        libswscale-dev from Build-Depends since they are in universe.
  * Dropped following changes, are fixed in Debian:
    - debian/strigi-daemon.install:
      + In strigi-daemon.install usr/bin/luceneindexer
        now usr/bin/lucene2indexer with new version of clucene.
    - debian/libstreams-dev.install:
      + Fix install file.

 -- Artur Rona <ari-tczew@ubuntu.com>  Mon, 17 Feb 2014 21:24:56 +0100

strigi (0.7.8-1) unstable; urgency=low

  * Team upload.
  * New upstream release.

  [ Maximiliano Curia ]
  * Remove patches applied upstream:
    - upstream_gcc47-fix-unistd.h-header-required-unconditionally-f.patch
    - id3_crash_fix.diff
  * Bump Standards-Version to 3.9.4.
  * Add myself to uploaders.
  * Update vcs fields.
  * Avoid symbols for internal so files.
  * Add a watch file.
  * New patch: deepgrep_mayhem_fix.diff (Closes: #715819) fix for
    http://www.forallsecure.com/bug-
    reports/18bb7c6dfe2b4ae87a2937f9678b812bb1bd5c8d/

  [ Pino Toscano ]
  * Force the libdir to the non-multiarch path, to keep compatibility with
    what has been done so far.
  * Update libstreams-dev.install to not rely on a specific cmake build type.
    (Closes: #707525)
  * Bump cmake build dependency to 2.8.9, as requested by the upstream build
    system.
  * Minor touches to some descriptions, including a typo fix.
    (Closes: #680641)
  * Update .install files.
  * Require clucene >= 2, and adapt strigi-daemon.install to the new indexer
    (lucene2indexer instead of luceneindexer). (Closes: #718373)
  * Explicitly build depend on pkg-config, instead of relying on it being
    installed by something else.
  * Link in as-needed mode.

 -- Pino Toscano <pino@debian.org>  Mon, 05 Aug 2013 00:08:36 +0200

strigi (0.7.7-3ubuntu6) trusty; urgency=low

  * Drop libprostproc-dev and libswscale-dev build-dependencies. (LP:
    #1243235)

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Wed, 30 Oct 2013 17:51:26 +0000

strigi (0.7.7-3ubuntu5) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Wed, 23 Oct 2013 10:53:37 +0100

strigi (0.7.7-3ubuntu4) saucy; urgency=low

  * Fix install files

 -- Rohan Garg <rohangarg@kubuntu.org>  Mon, 23 Sep 2013 17:24:52 +0200

strigi (0.7.7-3ubuntu3) saucy; urgency=low

  * Rebuild against boost 1.53.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 01 May 2013 00:02:53 +0100

strigi (0.7.7-3ubuntu2) raring; urgency=low

  * In strigi-daemon.install usr/bin/luceneindexer now usr/bin/lucene2indexer
    with new version of clucene

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 15 Nov 2012 15:42:49 +0000

strigi (0.7.7-3ubuntu1) raring; urgency=low

  * Merge from Debian unstable, remaining changes:
   - Drop libavcodec-dev and libavformat-dev from build-deps as libavcodec
     is not allowed on CD images.

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 15 Nov 2012 14:38:09 +0000

strigi (0.7.7-2ubuntu2) quantal; urgency=low

  * No-change rebuild against libexiv2-12.

 -- Felix Geyer <debfx@ubuntu.com>  Sun, 10 Jun 2012 01:01:23 +0200

strigi (0.7.7-2ubuntu1) quantal; urgency=low

  * Merge from Debian unstable, remaining changes:
   - Drop libavcodec-dev and libavformat-dev from build-deps as libavcodec
     is not allowed on CD images.

 -- Felix Geyer <debfx@ubuntu.com>  Wed, 09 May 2012 14:04:24 +0200

strigi (0.7.7-1.1ubuntu3) precise; urgency=low

  * Fix libstrigiqtdbusclient0.symbols for amd64 as well

 -- Scott Kitterman <scott@kitterman.com>  Wed, 11 Apr 2012 17:42:07 -0400

strigi (0.7.7-1.1ubuntu2) precise; urgency=low

  * Remove non-existant LibStreamsTargets-noconfig.cmake from
    libstreams-dev.install to fix FTBFS
  * Fix libstrigiqtdbusclient0.symbols

 -- Scott Kitterman <scott@kitterman.com>  Wed, 11 Apr 2012 17:06:22 -0400

strigi (0.7.7-1.1ubuntu1) precise; urgency=low

  * Merge with Debian; remaining changes:


=== debian/control ===
Source: strigi
Section: utils
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Fathi Boudra <fabo@debian.org>, Mark Purcell <msp@debian.org>,
           Maximiliano Curia <maxy@debian.org>
Build-Depends: cmake (>= 2.8.9),
               dbus-x11,
               debhelper (>= 9),
               libboost-dev,
               libbz2-dev,
               libclucene-dev (>= 2),
               libdbus-1-dev,
               libexiv2-dev,
               libqt4-dev (>= 4.4.3),
               libxml2-dev,
               libxml2-utils,
               pkg-config,
               pkg-kde-tools (>= 0.9.3),
               zlib1g-dev
Standards-Version: 3.9.4
Homepage: http://strigi.sourceforge.net
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-kde/kde-extras/strigi/trunk
Vcs-Svn: svn://anonscm.debian.org/pkg-kde/kde-extras/strigi/trunk

Package: strigi-daemon
Architecture: any
Depends: dbus-x11 | dbus, poppler-utils, ${misc:Depends}, ${shlibs:Depends}
Suggests: strigi-plugins
Description: fast indexing and searching tool for your personal data (daemon)
 Strigi is a program for fast indexing and searching your personal data. It can
 gather and index information from files in the filesystem even if they are
 hidden in emails or archives. It comes with a Qt4 GUI, an HTML GUI and a KDE
 GUI.
 .
 Main features:
  * very fast crawling
  * very small memory footprint
  * no hammering of the system
  * clucene backend
  * DBus and socket interfaces are available for communication between daemon
    and search programs
  * simple interface for implementing plugins for extracting information. we'll
    try to reuse the kat plugins, although native plugins will have a large
    speed advantage
  * calculation of sha1 for every file crawled (allows fast finding of
    duplicates)
 .
 This package contains the Strigi daemon

Package: strigi-client
Architecture: any
Section: x11
Depends: strigi-daemon, ${misc:Depends}, ${shlibs:Depends}
Description: Qt4 client for Strigi Desktop Search
 Strigi client is a Qt4 client (GUI) for the Strigi Desktop Search software.
 .
 This package is part of Strigi Desktop Search, it contains the Qt4 client.
 .
 See the 'strigi-daemon' package for more information.

Package: strigi-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: strigi-daemon (<< 0.3.11-1)
Description: command-line tools for Strigi Desktop Search
 This package is part of Strigi Desktop Search, it contains utilities powered
 by Strigi:
  * deepfind, an enhanced version of find. It lists files embedded in other
    files like .deb, .rpm, .tar.gz, email attachments, and other files.
  * deepgrep, an enhanced version of grep. It searches in binary files like
    OpenOffice files, mp3s, Microsoft office files, pdfs and also in files
    embedded in other files like .deb, .rpm, .tar.gz, email attachments, pdf
    and other files.
  * xmlindexer, a program that outputs the file parsing results as xml.
    It walks through a directory and outputs an XML file containing all
    the metadata and text it can extract from the files it encounters.
    This means that the Strigi's powers of data extraction are now available
    to all applications that can parse XML simply by calling xmlindexer and
    parsing the output.
 .
 See the 'strigi-daemon' package for more information.

Package: libstreams0v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libstreams0
Replaces: strigi-daemon (<< 0.3.11-1), libstreams0
Description: streams library for Strigi Desktop Search
 This package is part of Strigi Desktop Search; it contains a library for
 input streams of data.
 .
 See the 'strigi-daemon' package for more information.

Package: libstreams-dev
Architecture: any
Section: libdevel
Depends: libstreams0v5 (= ${binary:Version}), ${misc:Depends}
Description: development files for libstreams
 This package is part of Strigi Desktop Search; it contains the Strigi
 development files for libstreams.
 .
 See the 'strigi-daemon' package for more information.

Package: libstreamanalyzer0v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libstreamanalyzer0
Replaces: kdegraphics-strigi-plugins (<< 4:4.0.0-2),
          libcluceneindex0 (<< 0.5.6-1),
          libstreamindexer0 (<< 0.5.1-1),
          libstreamanalyzer0,
          strigi-daemon (<< 0.3.11-1)
Breaks: libcluceneindex0 (<< 0.5.6-1), libstreamindexer0 (<< 0.5.1-1)
Description: streamanalyzer library for Strigi Desktop Search
 This package is part of Strigi Desktop Search; it contains a library for
 analyzing data read from streams.
 .
 See the 'strigi-daemon' package for more information.

Package: libstreamanalyzer-dev
Architecture: any
Section: libdevel
Depends: libstreamanalyzer0v5 (= ${binary:Version}),
         libstreams-dev (= ${binary:Version}),
         ${misc:Depends}
Replaces: libcluceneindex-dev (<< 0.5.6-1), libstreamindexer-dev (<< 0.5.1-1)
Breaks: libcluceneindex-dev (<< 0.5.6-1), libstreamindexer-dev (<< 0.5.1-1)
Description: development files for libstreamanalyzer
 This package is part of Strigi Desktop Search; it contains the Strigi
 development files for libstreamanalyzer.
 .
 See the 'strigi-daemon' package for more information.

Package: libsearchclient0v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libsearchclient0
Replaces: strigi-daemon (<< 0.3.11-1), libsearchclient0
Description: searchclient library for Strigi Desktop Search
 This package is part of Strigi Desktop Search; it contains a library for
 writing search clients.
 .
 See the 'strigi-daemon' package for more information.

Package: libsearchclient-dev
Architecture: any
Section: libdevel
Depends: libsearchclient0v5 (= ${binary:Version}),
         libstreamanalyzer-dev (= ${binary:Version}),
         ${misc:Depends}
Description: development files for libsearchclient
 This package is part of Strigi Desktop Search; it contains the Strigi
 development files for libsearchclient.
 .
 See the 'strigi-daemon' package for more information.

Package: libstrigihtmlgui0v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libstrigihtmlgui0
Replaces: libstrigihtmlgui0
Description: library for writing html clients for Strigi Desktop Search
 This package is part of Strigi Desktop Search; it contains a library for
 writing HTML clients.
 .
 See the 'strigi-daemon' package for more information.

Package: libstrigihtmlgui-dev
Architecture: any
Section: libdevel
Depends: libsearchclient-dev (= ${binary:Version}),
         libstrigihtmlgui0v5 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for libstrigihtmlgui
 This package is part of Strigi Desktop Search; it contains the Strigi
 development files for libstrigihtmlgui.
 .
 See the 'strigi-daemon' package for more information.

Package: libstrigiqtdbusclient0v5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library for writing D-Bus clients for Strigi Desktop Search
 This package is part of Strigi Desktop Search; it contains a library for
 writing Qt D-Bus clients for strigi.
 .
 See the 'strigi-daemon' package for more information.

Package: libstrigiqtdbusclient-dev
Architecture: any
Section: libdevel
Depends: libqt4-dev (>= 4.4.0~),
         libstreams-dev (= ${binary:Version}),
         libstrigiqtdbusclient0v5 (= ${binary:Version}),
         ${misc:Depends}
Description: development files for libstrigiqtdbusclient
 This package is part of Strigi Desktop Search; it contains the Strigi
 development files for libstrigiqtdbusclient.
 .
 See the 'strigi-daemon' package for more information.

Package: strigi-dbg
Priority: extra
Architecture: any
Section: debug
Depends: libstreamanalyzer0v5 (= ${binary:Version}),
         libstreams0v5 (= ${binary:Version}),
         libstrigiqtdbusclient0v5 (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for strigi
 This package contains the debugging symbols associated with strigi.
 .
 They will automatically be used by gdb for debugging strigi related issues.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

FILENAME := $(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz
UPFILENAME := $(DEB_SOURCE_PACKAGE)-$(shell echo $(DEB_UPSTREAM_VERSION) | sed 's/~/-/').tar.bz2
URL := http://www.vandenoever.info/software/strigi/$(UPFILENAME)
CURRENTVERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')
LIBPKGS := $(filter-out %-dev,$(filter lib%,$(shell dh_listpackages)))

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --list-missing --dbg-package=strigi-dbg --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_REGENERATEXSD=OFF \
		-DCMAKE_INSTALL_LIBDIR=lib

override_dh_makeshlibs:
	dh_makeshlibs -V -Xusr/lib/strigi
	for pkg in $(LIBPKGS); do \
		sed 's/>=[^)]*/= $(CURRENTVERSION)/' debian/$$pkg/DEBIAN/shlibs >> debian/shlibs.local; \
	done

override_dh_clean:
	dh_clean
	rm -f debian/shlibs.local

override_dh_auto_test:

get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ] || mkdir -p ../tarballs
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget -N -nv -T10 -t3 -O ../tarballs/$(UPFILENAME) $(URL)
	@@echo Converting $(UPFILENAME) to $(FILENAME)
	@@bzcat ../tarballs/$(UPFILENAME) | gzip -9 > ../tarballs/$(FILENAME)

=== debian/watch ===
version=3
http://www.vandenoever.info/software/strigi/strigi-([\d.]+).tar.bz2
